<?php
namespace SCM\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Util\Validation;
use SCM\Traits\TResponse;

class Parametros extends \Zeedhi\Framework\Controller\Simple {
    
    use TResponse;

	protected $parametros;
	protected $environment;

	public function __construct(\SCM\Services\Parametros $parametros, $environment) {
        $this->parametros = $parametros;
        $this->environment = $environment;
    }

    public function retornaParametros(Request $request, Response $response) {
        try {
        // 	$filter = $request->getFilterCriteria()->getConditions();
            $params = $request->getParameters();
        	
            $cdfilial = $params['CDFILIAL'];
            // $nrorg = $filter[1]['value'];
            $nrorg = $this->environment->getNrorg();

            $parametrosFilial = $this->parametros->_retornaParametros($cdfilial, $nrorg);
            $this->sendResponse($parametrosFilial);
// 			$response->addDataSet(new DataSet('Parametros', $parametrosFilial));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function retornaParamGeral(Request $request, Response $response) {
        try {
        	$paramgeral = $this->parametros->retornaParamGeral();
            $this->sendResponse($paramgeral);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function retornaParamEstoque(Request $request, Response $response) {
        try {
        	$paramestoque = $this->parametros->retornaParamEstoque();
            $this->sendResponse($paramestoque);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
}