<?php
/**
 * Created by Luiz Filho
 */

namespace SCM\Model\Repository;

use Doctrine\ORM\EntityRepository;
use SCM\Traits\TQuery;

class AF extends EntityRepository {
    
    use TQuery;

    public function retornaAFs($nrorg, $filiais, $dtFinal, $dtInicial) {
        $dataSet = array();
	  	$sql = "SELECT IAF.CDFILDEST, IAF.CDFILLANC, IAF.NRAUTOFORN, IAF.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, P.SGUNIDADE,
                IAF.CDMARCA, M.NMMARCA, TO_CHAR(IAF.DTPROGENTAF, 'DD/MM/YYYY') AS DTPROGENTAF, NVL(IAF.VRPERDESAF, 0) AS VRPERDESAF, NVL(IAF.QTPROGENTAF, 0) AS QTPROGENTAF,
                NVL(IAF.VRPREUNIAF, 0) AS VRPREUNIAF, NVL(IAF.VRDESCITMAF, 0) AS VRDESCITMAF,
                ( ( NVL(IAF.QTPROGENTAF, 0) * NVL(IAF.VRPREUNIAF, 0) ) - NVL(IAF.VRDESCITMAF, 0) ) AS VRTOTALITEM,
                IAF.CDFILDEST || IAF.CDFILLANC || IAF.NRAUTOFORN || IAF.CDMARCA || IAF.CDPRODUTO || TO_CHAR(IAF.DTPROGENTAF, 'DDMMYYYY') as KEY,
                TO_CHAR(IAF.DTPROGENTAF, 'DD/MM/YYYY') AS DTINICIAL, TO_CHAR(IAF.DTPROGENTAF, 'DD/MM/YYYY') AS DTFINAL,
                FORN.NMRAZSOCFORN, FORN.NMFANTFORN
                FROM ITEMAUTF IAF
                JOIN (
                	/* RETORNA TODAS A NOTAS FICAIS DO PERIODO INFORMADO. PODE SER USADO PARA CRIAR O FILTRO POR NOTA FISCAL */
                	SELECT CDFILDEST, CDFILLANC, NRAUTOFORN, CDMARCA, CDPRODUTO
                	FROM ITEMAUTF
                	WHERE INSTR(:CDFILIAL, CDFILDEST) <> 0 
                	AND DTPROGENTAF BETWEEN TO_DATE(:DATAINICIAL, 'DD/MM/YYYY') AND TO_DATE(:DATAFINAL, 'DD/MM/YYYY')
                	AND NVL(IDBAIXITMAF, '1') = '1'
                	GROUP BY CDFILDEST, CDFILLANC, NRAUTOFORN, CDMARCA, CDPRODUTO
                	ORDER BY CDFILDEST, CDFILLANC, NRAUTOFORN, CDMARCA, CDPRODUTO
                ) AF
                	ON AF.CDFILDEST = IAF.CDFILDEST
                	AND AF.CDFILLANC = IAF.CDFILLANC
                	AND AF.NRAUTOFORN = IAF.NRAUTOFORN
                	AND AF.CDMARCA = IAF.CDMARCA
                    AND AF.CDPRODUTO = IAF.CDPRODUTO
                JOIN AUTOFORNE TAF 
                    ON AF.CDFILDEST = TAF.CDFILDEST
                    AND AF.CDFILLANC = TAF.CDFILLANC
                    AND AF.NRAUTOFORN = TAF.NRAUTOFORN
                    AND NVL(TAF.IDBAIXAAF, '1') = '1'
                    AND NVL(TAF.IDAFEXPIRADA, 'N') = 'N'
                JOIN PRODUTO P ON P.CDPRODUTO = IAF.CDPRODUTO
                JOIN MARCA M ON M.CDMARCA = IAF.CDMARCA
                JOIN FORNECEDOR FORN ON FORN.CDFORNECED = TAF.CDFORNECED
                ORDER BY DTPROGENTAF, IAF.NRAUTOFORN, IAF.CDFILDEST, IAF.CDFILLANC, P.NMPRODUTO";
// CDFILDEST = :CDFILIAL
	  	$params = array(
            'DATAINICIAL' => $dtInicial,
            'DATAFINAL' => $dtFinal,
            'CDFILIAL' => $filiais
		);
        // if (!is_array($filiais)) $filiais = [$filiais];
        // foreach ($filiais as $filial) {
        //     $params['CDFILIAL'] = $filial;
        //     $query = $this->getEntityManager()->getConnection()->prepare($sql);
        //     $query->execute($params);
        //     $dataSet = array_merge($dataSet, $query->fetchAll());
        // }
        return $this->createAndExecuteQueryAndBuildResponseData($this->getEntityManager(), $sql, $params);
    }
}