<?php

namespace SCM\Services;

use SCM\Util\Validation;

class Efetivos {

    private $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function retornaDatasCardapio($nrorg, $cdfilial, $dataInicial, $dataFinal) {
        return $this->entityManager->getRepository('SCM\Model\Efetivos')->retornaDatasCardapio($nrorg, $cdfilial, $dataInicial, $dataFinal);
    }

    public function retornaTiposCardapio($nrorg, $cdfilial, $dataInicial, $dataFinal) {
        return $this->entityManager->getRepository('SCM\Model\Efetivos')->retornaTiposCardapio($nrorg, $cdfilial, $dataInicial, $dataFinal);
    }

    public function retornaCardapio($nrorg, $cdfilial, $dataInicial, $dataFinal) {
        return $this->entityManager->getRepository('SCM\Model\Efetivos')->retornaCardapio($nrorg, $cdfilial, $dataInicial, $dataFinal);
    }

    public function retornaServicosCardapio($nrorg, $cdfilial, $dataInicial, $dataFinal) {
        return $this->entityManager->getRepository('SCM\Model\Efetivos')->retornaServicosCardapio($nrorg, $cdfilial, $dataInicial, $dataFinal);
    }

    public function retornaClientesDoServico($nrorg, $cdfilial, $dataInicial, $dataFinal, $cdservfili, $cdtipocard) {
        return $this->entityManager->getRepository('SCM\Model\Efetivos')->retornaClientesDoServico($nrorg, $cdfilial, $dataInicial, $dataFinal, $cdservfili, $cdtipocard);
    }
    
    public function retornaEfetivosRequisicao($nrorg, $filial, $dataInicial, $dataFinal, $cdservfili, $cdtipocard) {
        return $this->entityManager->getRepository('SCM\Model\Efetivos')->retornaEfetivosRequisicao($nrorg, $filial, $dataInicial, $dataFinal, $cdservfili, $cdtipocard);
    }

    public function update($row) {
        $params = array(
            'cdfilcentpme' => $row['CDFILCENTPME'],
            'nrcardpme' => $row['NRCARDPME'],
            'nrcardiapme' => $row['NRCARDIAPME'],
            'dtcardiapme' => $this->toDate($row['DTCARDIAPME']),
            'cdfilial' => $row['CDFILIAL'],
            'cdservfili' => $row['CDSERVFILI'],
        );
        $servico = $this->entityManager->getRepository('SCM\Model\Cardiapme')->findBy($params);
        if (empty($servico)) throw new \Exception('EDIT_NOT_FOUND: '.$row['DTCARDIAPME'].' - '.$row['NRCARDPME'].' - '.$row['NRCARDIAPME']);
        $servico[0]->setQtcomefecpme($row['QTCOMEFECPME']);
        $servico[0]->setQtcliefecpme($row['QTCLIEFECPME']);
        $servico[0]->setQtfunefecpme($row['QTFUNEFECPME']);
        $servico[0]->setQtdoaefecpme($row['QTDOAEFECPME']);

        $this->entityManager->persist($servico[0]);
        $this->entityManager->flush();
    }

    public function updateClientes($row, $nrorg, $cdoperador) {

        $params = array(
            'cdcliente' => $row['CDCLIENTE'],
            'cdfilcentpme' => $row['CDFILCENTPME'],
            'cdfilial' => $row['CDFILIAL'],
            'cdservfili' => $row['CDSERVFILI'],
            'cdtipocard' => $row['CDTIPOCARD'],
            'dtefetclpme' => $this->toDate($row['DTEFETCLPME']),
        );

        $cliente = $this->entityManager->getRepository('SCM\Model\Efetcliepme')->findBy($params);

        if (isset($cliente[0])) {

            $cliente[0]->setQtcomefclpme($row['QTCOMEFCLPME']);
            $cliente[0]->setQtfunefclpme($row['QTFUNEFCLPME']);
            $cliente[0]->setQtdoaefclpme($row['QTDOAEFCLPME']);

            $this->entityManager->persist($cliente[0]);
            $this->entityManager->flush();

        } else {

            $efetcliepme = new \SCM\Factory\Efetcliepme();
            
            $row['CDOPERADOR'] = $cdoperador;
            $row['NRORG'] = $nrorg;
            $novaEfetcliepme = $efetcliepme->criarEfetcliepme($row);

            $this->entityManager->persist($novaEfetcliepme);
            $this->entityManager->flush();
        }

    }
    
    private function toDate($stringDate) {
    // 	$explodeDate = explode("/", $stringDate);
    // 	$date = $explodeDate[2].'-'.$explodeDate[1].'-'.$explodeDate[0];
    // 	return $date;
        return $stringDate;
        // return \DateTime::createFromFormat("d/m/Y", $stringDate);
    }
}