<?php

namespace SCM\Services;

use SCM\Traits\TQuery;

class Parametros {
    
    use TQuery;

    private $entityManager;
    
    public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function retornaParametros($filiais, $nrorg) {

        $dataSet = array();

    	$sql = "SELECT NVL(F.CDFILCENTCMP, F.CDFILIAL) AS  CENTRAL,
                  F.CDFILIAL, 
                  NVL(IDBLOQALTSOLAVR, 'N') IDBLOQALTSOLAVR,
                  NVL(IDEXPSOLCMP, 'N') IDEXPSOLCMP,
                  NVL(IDUTILALMOX, 'N') IDUTILALMOX,
                  NVL(IDUTILLOTE, 'N') IDUTILLOTE,
                  NVL(IDUTPRODPREF, 'N') IDUTPRODPREF,
                  NVL(SUBSTR(IDPERALTSAPR, 1, 1), 'N') INCLUIR_PRODUTO_APROVADO, 
                  NVL(SUBSTR(IDPERALTSAPR, 2, 1), 'N') ALTERAR_PRODUTO_APROVADO,
                  NVL(SUBSTR(IDPERALTSAPR, 3, 1), 'N') DESAPROVAR_PRODUTO_ALTERADO,
                  IDUTAPROVSOL
                FROM FILIAL F 
                LEFT JOIN PARASUPRI P ON (NVL(F.CDFILCENTCMP, F.CDFILIAL) = P.CDFILIAL)
                LEFT JOIN PARAMFILIAL PF ON F.CDFILIAL = PF.CDFILIAL
                LEFT JOIN PARCMPSUP PCS ON F.CDFILIAL = PCS.CDFILIAL
                WHERE F.CDFILIAL = :CDFILIAL";

        $params = array(
            'CDFILIAL' => ''
        );
        if (gettype($filiais) == 'string') {
          $filiais = str_split($filiais, 4);
        }

        foreach ($filiais as $filial) {
            $params['CDFILIAL'] = $filial;
            $queryResult = $this->entityManager->getConnection()->fetchAll($sql, $params);
            $dataSet = array_merge($dataSet, $queryResult);
        }

        return $dataSet;
    }
    
    public function _retornaParametros($filiais, $nrorg) {

        $dataSet = array();

    	$sql = "SELECT NVL(F.CDFILCENTCMP, F.CDFILIAL) AS  CENTRAL,
                  F.CDFILIAL, 
                  NVL(IDBLOQALTSOLAVR, 'N') IDBLOQALTSOLAVR,
                  NVL(IDEXPSOLCMP, 'N') IDEXPSOLCMP,
                  NVL(IDUTILALMOX, 'N') IDUTILALMOX,
                  NVL(IDUTILLOTE, 'N') IDUTILLOTE,
                  NVL(IDUTPRODPREF, 'N') IDUTPRODPREF,
                  NVL(SUBSTR(IDPERALTSAPR, 1, 1), 'N') INCLUIR_PRODUTO_APROVADO, 
                  NVL(SUBSTR(IDPERALTSAPR, 2, 1), 'N') ALTERAR_PRODUTO_APROVADO,
                  NVL(SUBSTR(IDPERALTSAPR, 3, 1), 'N') DESAPROVAR_PRODUTO_ALTERADO,
                  IDUTAPROVSOL,
                  NVL(PF.IDLANCDTMENFIL, 'N') IDLANCDTMENFIL,
                  NVL(PF.IDLANCDTMAIFIL, 'N') IDLANCDTMAIFIL,
                  NVL(PF.DTPROCESSA, SYSDATE) DTPROCESSA,
                  NVL(PF.NRDIASSAIDFIL, 0) NRDIASSAIDFIL,
                  NVL(PF.NRDIASSAIDPDFIL, 0) NRDIASSAIDPDFIL,
                  IDUTREQUPRAT,
                  CDTPRETIPADR
                FROM FILIAL F 
                LEFT JOIN PARASUPRI P ON (NVL(F.CDFILCENTCMP, F.CDFILIAL) = P.CDFILIAL)
                LEFT JOIN PARAMFILIAL PF ON F.CDFILIAL = PF.CDFILIAL
                LEFT JOIN PARCMPSUP PCS ON F.CDFILIAL = PCS.CDFILIAL
                LEFT JOIN PARAMPLANEJA PP ON F.CDFILIAL = PP.CDFILIAL
                WHERE INSTR(:CDFILIAL, F.CDFILIAL) <> 0";
// F.CDFILIAL = :CDFILIAL
        $params = array(
            'CDFILIAL' => $filiais
        );
        // if (gettype($filiais) == 'string') {
        //   $filiais = str_split($filiais, 4);
        // }

        // foreach ($filiais as $filial) {
        //     $params['CDFILIAL'] = $filial;
        //     $queryResult = $this->entityManager->getConnection()->fetchAll($sql, $params);
        //     $dataSet = array_merge($dataSet, $queryResult);
        // }

        // return $dataSet;
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }
    
    public function retornaParamGeral() {
    	$sql = "SELECT CDPARGERAL, NVL(IDUTILDTPROC, 'N') IDUTILDTPROC FROM PARAMGERAL";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, array());
    }
    
    public function retornaParamEstoque() {
    	$sql = "SELECT CDPARESTOQ,
    	            PE.IDLANCDTMEN,
                   PE.IDLANCDTMAI,
                   NVL(PE.NRDIASSAID, 0) AS NRDIASSAID,
                   NVL(PE.NRDIASSAIDPD, 0) AS NRDIASSAIDPD
              FROM PARAMESTOQUE PE";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, array());
    }
}