/*
** mappingObj é o objeto que preencherá o dataSourceMapping
** vendorDir é o caminho até o vendor a partir do GruntFile
** relativePath é o caminho para os datasources a partir do index.php do módulo/produto
*/
module.exports = function(grunt, mappingObj, vendorDirRelativoGruntFile, vendorDirRelativoAIndexPHP){
    //Pega o nome do arquivo (com a extensão se desejado)
    var getFileName = (filePath, withExtension) => {
        var parts = filePath.split('/');
        var fileName = parts[parts.length - 1];
        if(withExtension)
            return fileName;
        parts = fileName.split('.');
        return parts[0];
    }
    
    //Adiciona todos os datasources do diretório no dataSourcesMapping
    var addDataSourcesMapping = (dir) => {
        grunt.file.expand({
			filter: 'isFile'
		}, dir + '/**/*.json').forEach(function (filePath) {
		    var fileNameAndExtension = getFileName(filePath, true);
		    var fileName = fileNameAndExtension.split('.')[0];
		    //Substitui o caminho inicial (./backend) pelo relativo ao index.php informado
		    var fileRelativePath = filePath.replace(/^.*\/backend\/vendor\//i, vendorDirRelativoAIndexPHP);
		    fileRelativePath = fileRelativePath.replace('/' + fileNameAndExtension, '');
		    mappingObj[fileName] = fileRelativePath;
		});
    }
    
    addDataSourcesMapping(vendorDirRelativoGruntFile + 'teknisa/tecfoodlib/datasources');
    
    //Todos os módulos da biblioteca
    var modules = grunt.file.expand({
	    filter: 'isDirectory'
	}, vendorDirRelativoGruntFile + 'teknisa/tecfoodlib/Modules/*');
	//Para cada módulo da biblioteca
	modules.forEach(function(module){
	    addDataSourcesMapping(module + '/datasources');
	});
	
	//Para dependências específicas
	//-- Validação de estoque
	var dir = vendorDirRelativoGruntFile + 'teknisa/pebLibraries';
	addDataSourcesMapping(dir + '/datasources');
}