<?php
/*Inicializa a biblioteca*/
function bootstrapTecfoodLib(&$instanceManager, &$routes, $vendorDir){
	
	//Biblioteca de evolução do estoque - uso no módulo PLA
	$pebLibDir = $vendorDir . "teknisa/pebLibraries/";
	require $pebLibDir . "bootstrap.php";
	$routes[] = $pebLibDir . 'config/pebLib.json';
	
	//Serviços gerais da biblioteca
	$instanceManager->loadFromFile(__DIR__ . "/config/services.xml");
	$routes[] = __DIR__.'/config/routes.json';
	
	//Percorre os módulos criados, declarando seus servicos e rotas
	$modulesDir = __DIR__."/Modules/";
	$modulesFolders = array_diff(scandir($modulesDir), [".", ".."]);
	foreach($modulesFolders as $module){ //Le todos diretorios dentro da pasta Modules de forma dinamica
	    $files = array_diff(scandir($modulesDir.$module."/config"), [".", ".."]);
	    foreach($files as $file){ //Le todos arquivos dentro da pasta config e separa entre json e xml
	        $extension = explode(".",$file)[1];
	        if($extension == 'json')
	            $routes[] = $modulesDir.$module."/config/".$file;   //leitura dinamica dos arquivos .json
	        else
	            $instanceManager->loadFromFile($modulesDir.$module."/config/".$file); //leitura dinamica dos arquivos .xml
	    }
	}
}